/* implementation */

#include <wtypes.h>
#include <wincon.h>
#include "curses.h"
#include "curses-internal.h"

int tryBeep() {
  char *buf = "\a";
  int howMany;
  if(! cursInitDone) return ERR;

  if(! WriteConsole(cursThisWin->hConOut, buf, 1, &howMany, NULL)) return ERR;

  return OK;
}

int tryFlash() {
  /* invert screen, and uninvert it */
  return ERR;
}

int beep(void) {
  if(! cursInitDone) return ERR;

  if(tryBeep() == ERR) return tryFlash();
  return OK;
}

int flash(void) {
  if(! cursInitDone) return ERR;

  if(tryFlash() == ERR) return tryBeep();
  return OK;
}

WINDOW *initscr(void) {
  CONSOLE_SCREEN_BUFFER_INFO csbi;

  /* it's in the example, so it must be good */
  /* "if X=0,Y=0, we ran from a GUI, else not" */
  GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),&csbi);
  if (csbi.dwCursorPosition.X | csbi.dwCursorPosition.Y) /* either non-zero? */
  {
    /* if we didn't, then give ourselves a fresh one */
    FreeConsole();
    AllocConsole();
  }
  SetConsoleTitle("ncurses application");

  cursThisWin = (WINDOW *)malloc(sizeof(WINDOW));
  cursThisWin->hConOut = GetStdHandle(STD_OUTPUT_HANDLE);
  cursThisWin->hConIn = GetStdHandle(STD_INPUT_HANDLE);
  cursThisWin->winContents = (chtype **)malloc((sizeof(chtype)) * (csbi.dwSize.X*csbi.dwSize.Y));

  cursInitDone = TRUE;
  
  return cursThisWin;
}

int endwin(void) {
  return OK;
}

int start_color(void) { 
  cursAllowColour = TRUE;
  return OK;
}

int init_pair(short pair, short f, short b) {
  struct cursColourPair *newPair = cursFirstPair;

  while((newPair != NULL) && (newPair->pairNum != pair))
    newPair = newPair->next;

  if(newPair == NULL) {
    newPair = (struct cursColourPair *)malloc(sizeof(struct cursColourPair));
    newPair->pairNum = pair;
    newPair->next = NULL;

    if(cursFirstPair == NULL) {
      cursFirstPair = newPair;
      cursLastPair = newPair;
    } else {
      cursLastPair->next = newPair;
      cursLastPair = newPair;
    }
  }

  newPair->colourNum = cursFGCols[f] | cursBGCols[b];

  return OK;
}

int clear(void) { return OK; }
int move(int x, int y) { return OK; }
int addch(chtype ch) { return OK; }
int addstr(char *str) { return OK; }
int standout(void) { return OK; }
int standend(void) { return OK; }
int clrtoeol(void) { return OK; }
int cbreak(void) { return OK; }
int getch(void) { return OK; }
int refresh(void) { return OK; }
int printw(char *arg, ...) { return OK; }