#ifndef _CURSES_H
#define _CURSES_H

/* defines, typedefs, etc */

#define RETSIGTYPE void
#define GCC_NORETURN /* nothing */
#define ERR     (-1)
#define OK      (0)

typedef unsigned long chtype;

struct cursWindowData {
  HANDLE hConOut;
  HANDLE hConIn;
  chtype **winContents;
};

typedef struct cursWindowData WINDOW;

/* colors */

#define COLOR_BLACK	0
#define COLOR_RED	1
#define COLOR_GREEN	2
#define COLOR_YELLOW	3
#define COLOR_BLUE	4
#define COLOR_MAGENTA	5
#define COLOR_CYAN	6
#define COLOR_WHITE	7

#define COLOR_PAIR(n)	(n << 8) // so as not to clash with the actual char.

/* functions */

WINDOW *initscr(void);
int endwin(void);

int beep(void);
int flash(void);

int clear(void);
int move(int, int);
int addch(chtype );
int addstr(char *);
int standout(void);
int standend(void);
int clrtoeol(void);
int cbreak(void);
int getch(void);
int refresh(void);
int start_color(void);
int init_pair(short, short, short);
int printw(char *, ...);

#endif
